﻿using System;
using System.Drawing;
using System.Threading;
using CC_Functions.Commandline;
using CC_Functions.Commandline.TUI;
using CC_Functions.Core;

namespace CLITest
{
    internal class Program
    {
        private static void Main()
        {
            Thread.CurrentThread.ForceInvariantCulture();
            //Parse test
            if (new ArgsParse(new[] { "--meme", "Fuk u", "--meme:yeet", "--meme:yote", "--meme" })["meme"] != "yote")
                throw new Exception("ArgsParse error 1");
            if (!new ArgsParse(new[] { "--meme", "Fuk u", "--meme:yeet", "--meme:yote", "--meme" }).GetBool("meme"))
                throw new Exception("ArgsParse error 2");
            if (new ArgsParse(new[] {"--meme:"}).GetBool("meme"))
                throw new Exception("ArgsParse error 3");
            if (!new ArgsParse(new[] {"--meme:true"}).GetBool("mEme"))
                throw new Exception("ArgsParse error 4");
            if (new ArgsParse(new[] {"--meme:1.1.2019"}).Get<DateTime>("meme") != new DateTime(2019, 1, 1))
                throw new Exception("ArgsParse error 5");
            if (new ArgsParse(new[] {"--meme:2019"}).Get("meme", s => s == null ? DateTime.Now : DateTime.Parse("1.1." + s)) != new DateTime(2019, 1, 1))
                throw new Exception("ArgsParse error 6");
            
            //Display test
            Console.BackgroundColor = ConsoleColor.Black;
            Console.ForegroundColor = ConsoleColor.White;
            Console.Clear();
            CenteredScreen cScreen = new CenteredScreen(40, 20, ConsoleColor.Green);
            Panel screen = cScreen.ContentPanel;
            Button btn1 = new Button("Test")
            {
                Point = new Point(2, 0),
                BackColor = ConsoleColor.DarkGreen
            };
            screen.Controls.Add(btn1);
            btn1.Click += (screen1, eventArgs) => { DiffDraw.Draw(true, true); };
            Label lab1 = new Label("Meem")
            {
                Point = new Point(2, 1),
                BackColor = ConsoleColor.Green
            };
            screen.Controls.Add(lab1);
            screen.Controls.Add(new Label("Saas\nSoos")
            {
                Point = new Point(2, 2),
                BackColor = ConsoleColor.Green
            });
            Button btn2 = new Button("X")
            {
                BackColor = ConsoleColor.Red,
                ForeColor = ConsoleColor.White
            };
            screen.Controls.Add(btn2);

            CheckBox box = new CheckBox("Are u gae?")
            {
                Point = new Point(2, 3),
                BackColor = ConsoleColor.DarkGreen
            };
            screen.Controls.Add(box);
            box.CheckedChanged += (screen1, eventArgs) => { lab1.Content = box.Checked ? "Sas" : "Meem"; };

            TextBox tbox = new TextBox("Hello\nWorld1\n\nHow are u?")
            {
                Size = new Size(20, 10),
                Point = new Point(0, 6),
                BackColor = ConsoleColor.DarkYellow
            };
            screen.Controls.Add(tbox);

            Slider slider = new Slider
            {
                Point = new Point(2, 4),
                Size = new Size(16, 2),
                MaxValue = 75,
                StepSize = 14,
                MinValue = -3,
                Value = 7,
                BackColor = ConsoleColor.Magenta
            };
            screen.Controls.Add(slider);

            bool visible = true;
            btn2.Click += (screen1, eventArgs) => visible = false;
            cScreen.Close += (screen1, eventArgs) => visible = false;
            cScreen.TabChanged += (screen1, eventArgs) => btn1.Content = $"Test {cScreen.TabPoint}";
            cScreen.Render();
            while (visible)
            {
                Thread.Sleep(50);
                cScreen.ReadInput();
            }
            Console.ResetColor();
            Console.Clear();
            Console.WriteLine("Test2");
            Thread.Sleep(100);
            DiffDraw.Clear(10, 10);
            DiffDraw.Draw(true, false);
            Console.Clear();
            Console.WriteLine("Bye");
        }
    }
}